
<p>Kroz prethodne lekcije započeli smo upoznavanje s digitalnim sustavima. Upoznali smo se s načinom na koji se brojevi te druge vrste podataka predstavljaju u digitalnim sustavima. Sada je vrijeme da krenemo korak dalje, i pogledamo na koji način možemo graditi digitalne sklopove koji rade obradu tih podataka. Da bismo to mogli, moramo se upoznati s <em>Booleovom algebrom</em> - matematičkim formalizmom koji će nam pomoći pri opisivanju funkcija digitalnih sklopova i koji će nam omogućiti da napravimo prijelaz od jednog digitalnog sklopa ka drugom funkcijski ekvivalentnom digitalnom sklopu koji ima nešto povoljnije karakteristike (primjerice, njegova sklopovska realizacija troši manje sklopova).</p>

<p>Formalizacija Booleove algebre započeta je još tijekom devetnaestog stoljeća. Poželimo li izdvojiti nekoliko najznačajnijih ranih radova, tada bi to svakako bili <a href="https://archive.org/details/mathematicalanal01bool"><em>The Mathematical Analysis of Logic, Being an Essay towards a Calculus of Deductive Reasoning</em></a> iz 1848. godine te <a href="https://archive.org/details/investigationofl00boolrich" target="_blank"><em>An Investigation of the Laws of Thought on Which are Founded the Mathematical Theories of Logic and Probabilities</em></a> iz 1854. godine, oba engleskog matematičara, filozofa i logičara Georgea Boolea koji razvija temelj na kojem je kasnije stvorena danas poznata Booleova algebra. Samoj formalizaciji Booleove algebre kakvu danas znamo doprinijelo je još nekoliko znanstvenika, a mi ćemo ovdje izdvojiti onu američkog matematičara Edwarda Vermilyea Huntingtona iz 1904. godine, danu kao niz Huntingtonovih postulata.</p>

<p>Za konačan oblik Booleove algebre kakav danas koristimo jednim dijelom je zaslužan i američki matematičar inženjer elektrotehnike Claude Elwood Shannon (također poznat kao <em>otac teorije informacija</em>) koji je 30-ih godina dvadesetog stoljeća proučavao izgradnju digitalnih sklopova ostvarivanih relejnim sklopkama. U okviru svojeg magistarskog rada <a href="https://dspace.mit.edu/handle/1721.1/11173" target="_blank"><em>A symbolic analysis of relay and switching circuits</em></a> napravljenog na američkom sveučilištu MIT 1936. godine, Shannon radi formalizaciju logike koja opisuje rad relejnih mreža i povezuje ju s Huntingtonovim postulatima. U magistarskom radu, Shannon koristi varijable kako bi opisivao stanja sklopki. Varijable mogu poprimiti samo dvije vrijednosti: 0 ili 1. U Shannonovoj formalizaciji, vrijednost 0 predstavlja uključenu sklopku (otpor između krajeva sklopke je vrlo mali odnosno 0), a vrijednost 1 predstavlja isključenu sklopku (veliki otpor). Operator \(+\), odnosno izraz \(x+y\), Shannon koristi za reprezentaciju serijskog spoja dviju sklopki dok operator \( \cdot \) odnosno izraz \( x \cdot y \) Shannon koristi za reprezentaciju paralelnog spoja dviju sklopki. Takva interpretacija u potpunosti se podudara s tablicama logičkih operatora ILI i I kakve inače koristimo. Evo ilustracije za operator \(+\) odnosno za serijski spoj sklopki.</p>

<table class="mlTableCC">
<tbody>
<tr><td><img src="@#file#(shannon-c00.svg)" alt="Slučaj 0+0=0"><br>a) 0+0=0</td></tr>
<tr><td><img src="@#file#(shannon-c01.svg)" alt="Slučaj 0+1=1"><br>b) 0+1=1</td></tr>
<tr><td><img src="@#file#(shannon-c10.svg)" alt="Slučaj 1+0=1"><br>c) 1+0=1</td></tr>
<tr><td><img src="@#file#(shannon-c11.svg)" alt="Slučaj 1+1=1"><br>d) 1+1=1</td></tr>
</tbody>
</table>

<p>U prvom retku imamo situaciju gdje su obje sklopke uključene (vrlo malog otpora); otpor serijskog spoja takvih dviju sklopki opet je vrlo mali pa se čitava serija ponaša kao jedna uključena sklopka. U drugom retku prva je sklopka uključena (mali otpor) a druga je isključena (veliki otpor); serijski spoj takvih dviju sklopki ponaša se kao jedna isključena sklopka: otpor između lijevog kontakta prve sklopke u seriji i desnog kontakta druge sklopke u seriji je veliki. Slično razmatranje vrijedi i za preostala dva retka. Ovu formalizaciju Shannon daje u svom magistarskom radu na stranicama 5 i 6 gdje se opisuje serijski i paralelni spoj releja i daje formalizacija postulatima.</p>

<p> Tako dobivena algebra koja je definirana nad dvočlanim skupom {0,1} samo je jedna od mogućih općenitih Booleovih algebri i upravo ona na koju, ako drugačije nije rečeno, mislimo kada govorimo o Booleovoj algebri. Pri tome je u današnje doba uobičajeno značenje vrijednosti 0 i 1 te operatora \(+\) i \(\cdot\) nešto drugačije: vrijednost 0 uobičajeno označava isključenu sklopku a vrijednost 1 uključenu sklopku. Uz takvu semantiku operator \(+\) predstavlja paralelni spoj sklopki (kažemo "<em>paralela se ponaša kao uključena sklopka kad je uključena prva sklopka ili druga sklopka</em>") a operator \(\cdot\) predstavlja serijski spoj sklopki (kažemo "<em>serija se ponaša kao uključena sklopka kad su uključene prva sklopka i druga sklopka</em>").</p>

<p>Pogledajmo stoga kako je uporabom Huntingtonovih postulata definirana Booleova algebra.</p>


